/// Generated By XFlutter Cli.
///
/// more info: https://xflutter-cli.aghiadodeh.com
import 'package:flutter/material.dart';
import 'package:flutterx_live_data/flutterx_live_data.dart';
import "package:flutter_mvvm_example/ui/widgets/singleton/singleton_state.dart";
import "./viewmodels/home_viewmodel.dart";
import 'package:flutter_mvvm_example/ui/widgets/snackbar.dart';
import 'package:flutter_mvvm_example/ui/core/responsive/screen_type_layout.dart';
import 'mobile/home_mobile_screen.dart';
import 'package:flutter_mvvm_example/ui/core/layouts/base_scaffold.dart';

class HomeScreen extends StatefulWidget {
  const HomeScreen({Key? key}) : super(key: key);

  @override
  State<HomeScreen> createState() => _HomeScreenState();
}

class _HomeScreenState extends State<HomeScreen> with SingletonState<HomeScreen, HomeViewModel>, StateObserver {
  @override
  void onInitState(HomeViewModel viewModel) {
    viewModel.listen();
    viewModel.getPaginationList();
  }

  @override
  Widget screen(BuildContext context, viewModel) {
    return Stack(
      children: [
        BaseScaffold(
          builder: (context, theme) {
            return const ScreenTypeLayout(mobile: HomeMobileScreen());
          },
        ),
        SnackBarMessageListener(uiMessage: viewModel.homeParams.uiMessage),
      ],
    );
  }

  @override
  HomeViewModel registerInstance() => HomeViewModel();
}
